using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for TrainRBFLN.
	/// </summary>
	public class TrainRBFLN : System.Windows.Forms.Form
	{
		int checkit1;
		int checkit2;
		double MSE,SSE;
		double SumError;

		public static double		checkstatus;		
		public static string		inFile1;			//names of input data files
		public static string		outFile;			//name of output data file

		char						NewLine		= (char)13;
		char						Return		= (char)10;

		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TrainRBFLN()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TrainRBFLN));
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.button5 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.button3 = new System.Windows.Forms.Button();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.button4 = new System.Windows.Forms.Button();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox5.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox5
			// 
			this.groupBox5.BackColor = System.Drawing.Color.Transparent;
			this.groupBox5.Controls.Add(this.label3);
			this.groupBox5.Controls.Add(this.label2);
			this.groupBox5.Controls.Add(this.button5);
			this.groupBox5.Controls.Add(this.button7);
			this.groupBox5.Controls.Add(this.label4);
			this.groupBox5.Controls.Add(this.button3);
			this.groupBox5.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox5.ForeColor = System.Drawing.Color.Black;
			this.groupBox5.Location = new System.Drawing.Point(24, 270);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(304, 136);
			this.groupBox5.TabIndex = 11;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Step 4:  Train RBFLN";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(32, 104);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(24, 16);
			this.label3.TabIndex = 3;
			this.label3.Text = "[3]";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(32, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(24, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "[1]";
			// 
			// button5
			// 
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button5.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.ForeColor = System.Drawing.Color.Black;
			this.button5.Location = new System.Drawing.Point(80, 24);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(136, 23);
			this.button5.TabIndex = 0;
			this.button5.Text = "Run";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// button7
			// 
			this.button7.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button7.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button7.ForeColor = System.Drawing.Color.Black;
			this.button7.Location = new System.Drawing.Point(80, 64);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(136, 24);
			this.button7.TabIndex = 0;
			this.button7.Text = "Save Training Results";
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(32, 64);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(24, 16);
			this.label4.TabIndex = 22;
			this.label4.Text = "[2]";
			// 
			// button3
			// 
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button3.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.ForeColor = System.Drawing.Color.Black;
			this.button3.Location = new System.Drawing.Point(80, 104);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(136, 23);
			this.button3.TabIndex = 1;
			this.button3.Text = "Return";
			this.button3.Click += new System.EventHandler(this.button3_Click_1);
			// 
			// groupBox4
			// 
			this.groupBox4.BackColor = System.Drawing.Color.Transparent;
			this.groupBox4.Controls.Add(this.button4);
			this.groupBox4.Controls.Add(this.textBox3);
			this.groupBox4.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox4.Location = new System.Drawing.Point(24, 188);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(304, 64);
			this.groupBox4.TabIndex = 10;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Step 3: Select Path and Name for Training Results !";
			this.groupBox4.Enter += new System.EventHandler(this.groupBox4_Enter);
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button4.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.ForeColor = System.Drawing.Color.Black;
			this.button4.Location = new System.Drawing.Point(208, 24);
			this.button4.Name = "button4";
			this.button4.TabIndex = 1;
			this.button4.Text = "Save As";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(16, 24);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(184, 22);
			this.textBox3.TabIndex = 0;
			this.textBox3.Text = "";
			this.textBox3.TextChanged += new System.EventHandler(this.textBox3_TextChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.BackColor = System.Drawing.Color.Transparent;
			this.groupBox2.Controls.Add(this.button2);
			this.groupBox2.Controls.Add(this.textBox1);
			this.groupBox2.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(24, 106);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(304, 64);
			this.groupBox2.TabIndex = 9;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Step 2: Input Training Data File !";
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(208, 24);
			this.button2.Name = "button2";
			this.button2.TabIndex = 1;
			this.button2.Text = "Load File";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(184, 22);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.Transparent;
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.Location = new System.Drawing.Point(24, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(304, 64);
			this.groupBox1.TabIndex = 8;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Step 1: Read Instruction Before Processing Data!";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(104, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Instructions";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox4
			// 
			this.textBox4.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox4.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox4.Location = new System.Drawing.Point(360, 56);
			this.textBox4.Multiline = true;
			this.textBox4.Name = "textBox4";
			this.textBox4.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox4.Size = new System.Drawing.Size(400, 352);
			this.textBox4.TabIndex = 19;
			this.textBox4.Text = "";
			this.textBox4.TextChanged += new System.EventHandler(this.textBox4_TextChanged);
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Transparent;
			this.label1.Font = new System.Drawing.Font("Times New Roman", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(368, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(368, 23);
			this.label1.TabIndex = 21;
			this.label1.Text = " The RBFLN training results will  be shown in this box";
			// 
			// TrainRBFLN
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(800, 462);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textBox4);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "TrainRBFLN";
			this.Text = "RBFLN Training";
			this.Load += new System.EventHandler(this.TrainRBFLN_Load);
			this.groupBox5.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void button2_Click(object sender, System.EventArgs e)
		{
			
			textBox4.Clear();	
			
			openFileDialog1.Filter = "dta Files (*.dta)|*.dta|All files (*.*)|*.*" ;


			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{						
				textBox1.Text = openFileDialog1.FileName;
				inFile1 = openFileDialog1.FileName;				
				
			}					
			
			this.textBox4.AppendText(" Training data file has been read successfully ! " + NewLine + Return+ NewLine + Return );
			this.textBox4.AppendText("" + textBox1.Text + NewLine + Return+NewLine + Return);
			this.textBox4.AppendText(" Please go to Step 3 ! ");
			
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			
			textBox4.Clear();
			saveFileDialog1.Filter = "par Files (*.par)|*.par|All files (*.*)|*.*" ;
					
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				textBox3.Text = saveFileDialog1.FileName;
				outFile = saveFileDialog1.FileName;
				checkit2 = 1;

				this.textBox4.AppendText("The Result of the Radial Basis Function Link Network for each vector will be saved in the following file : "+ NewLine+Return + NewLine + Return);
				this.textBox4.AppendText(""+ textBox3.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText("Please click Run button! "+ NewLine+Return);
				
			}

			else
			{
				checkit2 = 0;
			}
			
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			textBox4.Clear();		
			
			
			//----------------Main Function----------------------------------------------
			int    j, q;

			

			double minGoodness = 9999.99;
			double maxGoodness = 0;
	
			double[] TrainingGoodness = new double[2000];
			
			checkit1 = RbflnFunctions.readfile1();				
			
			
			if (( checkit1 == 1)&&(checkit2 ==1))
	
			{	
								    

					RbflnM dlg = new RbflnM();

					dlg.ShowDialog();
					checkstatus =0;										
				
				RbflnFunctions.learnmenu();	
				
				this.textBox4.AppendText("   " + "Vector No." + "       " + " Fuzzy Target "+ "       "  + " Training Fuzzy Beliefs " + NewLine + Return);
			
				this.textBox4.AppendText("----------------------------------------------------------" + NewLine + Return);
				
				for ( j = 0; j< RbflnFunctions.J;j++)
				{
					for ( q = 0; q< RbflnFunctions.Q; q++)
					{
				
						if (q<9)
						{
							this.textBox4.AppendText("          " + Convert.ToString(q+1));
				
						}

						else if (q<99)
						{
							this.textBox4.AppendText("        " + Convert.ToString(q+1));

						}

						else if (q<999)
						{
							this.textBox4.AppendText("      " + Convert.ToString(q+1));

						}
						
						//this.textBox4.AppendText("                 " + Convert.ToString(String.Format("{0:0.0000}" ,(RbflnFunctions.z[j,q]))));
						this.textBox4.AppendText("                     " + Convert.ToString(String.Format("{0:0.000}", RbflnFunctions.fuzzytruth[q])));
						this.textBox4.AppendText("                     " + Convert.ToString(String.Format("{0:0.0000}" , (RbflnFunctions.TrainingBelief [q]))) + NewLine + Return);
					}				
				}

					this.textBox4.AppendText("---------------------------------------------------------"+ NewLine + Return);	
				
					this.textBox4.AppendText(" RBFLN Training Overall-Measures : " + NewLine + Return);
				
				for (q=0;q<RbflnFunctions.Q;q++)
					{						
						
						if (RbflnFunctions.TrainingBelief[q] < minGoodness) 
						{
							minGoodness = RbflnFunctions.TrainingBelief[q];
						}						
					}
			
				
				
				
				for (q=0;q<RbflnFunctions.Q;q++)
				{						
						
					if (RbflnFunctions.TrainingBelief [q] > maxGoodness) 
					{
						maxGoodness = RbflnFunctions.TrainingBelief[q];
					}						
				}
				
				SumError = 0;
				for (q=0;q<RbflnFunctions.Q;q++)
				{						
						
					SumError = SumError+ Math.Pow((RbflnFunctions.TrainingBelief[q]-RbflnFunctions.fuzzytruth[q]),2);				
				}

				MSE = SumError/RbflnFunctions.Q;
				SSE = SumError;
								
				this.textBox4.AppendText(" Minimum Fit to Class : " + Convert.ToString(String.Format("{0:0.0000}" ,minGoodness))+ NewLine + Return);
				this.textBox4.AppendText(" Maximum Fit to Class : " + Convert.ToString(String.Format("{0:0.0000}" ,maxGoodness))+NewLine + Return);
				this.textBox4.AppendText(" MSE = " + Convert.ToString(String.Format("{0:0.0000}" , MSE)) + NewLine + Return);
				this.textBox4.AppendText(" SSE = " + Convert.ToString(String.Format("{0:0.00000}" ,SSE)));

				
				
			}

			else
			{
			
				MessageBox.Show(" Please input valid files before running ! !");
			}

		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			RbflnTrainingInstruction dlg = new RbflnTrainingInstruction();
			dlg.ShowDialog();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			
		}

		private void groupBox3_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void TrainRBFLN_Load(object sender, System.EventArgs e)
		{
		
		}

		private void textBox3_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox4_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
						
			RbflnTrainingResult dlg1 = new RbflnTrainingResult();
			dlg1.ShowDialog();

		}

		private void button3_Click_1(object sender, System.EventArgs e)
		{
						
			this.Close();					
			
		}

		private void textBox4_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button6_Click_1(object sender, System.EventArgs e)
		{
			
		}

		private void groupBox1_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
